#include <iostream>
#include <memory>
#include <string>

using std::endl;
using std::cout;

using std::string;

using std::auto_ptr;

void printAutoPtr(const string& name, const auto_ptr<int>& autoPtr){

  cout << name << ": " << autoPtr.get();
  if (autoPtr.get()) cout << " value: " << *autoPtr;
  cout << endl;

}

void catchResource(auto_ptr<int> localInt){
  printAutoPtr("localInt.get()",localInt);
}

int main(){

  cout << endl;

  cout << "auto_ptr<int> autoPtr1{new int(2011)}" << endl;
  auto_ptr<int> autoPtr1{new int(2011)};
  printAutoPtr("autoPtr1.get()",autoPtr1);

  cout << endl;

  cout << "auto_ptr<int> autoPtr2(autoPtr1)" << endl;
  auto_ptr<int> autoPtr2(autoPtr1);
  printAutoPtr("autoPtr1.get()",autoPtr1);
  printAutoPtr("autoPtr2.get()",autoPtr2);

  cout << endl;

  cout << "catchResource(autoPtr2)" << endl;
  catchResource(autoPtr2);
  printAutoPtr("autoPtr2.get()",autoPtr2);

  cout << endl;

}

